(function() {
    var bannerUnit = undefined;
    var interstitialUnit = undefined;
    var rewardedUnit = undefined;
    var isInterstitialLoaded = false;
    var isRewardedLoaded = false;

    var hasReward = null;

    window.AdMobInit = function(loaded, resume) {
        document.addEventListener('deviceready', () => {
            
            admob.start().then(() => {
                admob.configRequest({
                    testDeviceIds: ["2A7DB583908466AF0174A909BD06EDCF"]
                });    
                
                loaded();

                bannerUnit = new admob.BannerAd({
                    adUnitId: 'ca-app-pub-3916029314503991/1461068907',
                    size: 0
                });

                interstitialUnit = new admob.InterstitialAd({
                    adUnitId: 'ca-app-pub-3916029314503991/5158455543'
                });

                rewardedUnit = new admob.RewardedAd({
                    adUnitId: 'ca-app-pub-3916029314503991/9398025408',
                });

                loadInterstitial();
                loadRewarded();
            }, (err) => {
        
            });
            

            document.addEventListener("admob.interstitial.dismiss", function() {
                resume();
                loadInterstitial();
            });
            document.addEventListener("admob.interstitial.showFail", function() {
                resume();
            });
            document.addEventListener("admob.rewarded.dismiss", function() {
                resume();
                loadRewarded();
            });
            document.addEventListener("admob.rewarded.showFail", function() {
                resume();
            });
            document.addEventListener("admob.rewarded.reward", function() {
                if (hasReward != null) {
                    hasReward();
                    hasReward = null;
                }
            });
        });
    }

    function loadInterstitial() {
        interstitialUnit.load().then(() => {
            isInterstitialLoaded = true;
        }, (err) => {
        });
    }

    function loadRewarded() {
        rewardedUnit.load().then(() => {
            isRewardedLoaded = true;
        }, (err) => {

        });
    }

    window.AdMobShowBanner = function() {
        if (bannerUnit !== undefined)
            bannerUnit.show();
    }

    window.AdMobHideBanner = function() {
        if (bannerUnit !== undefined)
            bannerUnit.hide();
    }

    window.AdMobInterstitialLoaded = function() {
        return isInterstitialLoaded;
    }

    window.AdMobShowInterstitial = function() {
        if (interstitialUnit === undefined) return;

        isInterstitialLoaded = false;
        interstitialUnit.show().then(() => {
        }, () => {

        });
    }

    
    window.AdMobRewardedLoaded = function() {
        return isRewardedLoaded;
    }

    window.AdMobShowRewarded = function(andThenPleaseDoThis) {
        if (rewardedUnit === undefined) return;

        isRewardedLoaded = false;
        rewardedUnit.show().then(() => {
            //loadRewarded();
        }, () => {
            
        });
        hasReward = andThenPleaseDoThis;
    }

    window.doConsentStuff = function(ifNotEU) {
        var knownStatus = localStorage.getItem('consentstuff');

        if (knownStatus === "L2") {
            ifNotEU();
            return;
        } else if (knownStatus === "L1") {
            return;
        }

        if (window['Consent'])
            window['Consent'].verifyConsent(["pub-3916029314503991"], "https://florianvanstrien.nl/privacy.html", false, false, (cr) => {
                console.log(cr);
                if (cr.isNotInEea) {
                    ifNotEU();
                    localStorage.setItem('consentstuff', "L2")
                } else localStorage.setItem('consentstuff', "L1")
            }, () => {
                //ignore loudly
            });
    }
})();